/*
 * Problem: Flood-IT
 * Author: Alexander "espr1t" Georgiev
 * Contest: CodeIT 2011, Round 1
 * Keywords: Greedy, NP
 */

#include <cstdio>
#include <ctime>
#include <algorithm>
#include <vector>
#include <queue>
#include <cstring>
#include <map>

#define MAX 131072
#define INF 999666333

#define MAX_SIZE 360
#define MAX_MOVES 67600
#define MAX_COLORS 512

using namespace std;

struct Cell
{
	int row, col;
	Cell(int row_ = 0, int col_ = 0) : row(row_), col(col_) {}
};

int moves[MAX_MOVES];
int ansRow, ansCol, ansMoves;
int dir[4][2] = { {-1, 0}, {0, 1}, {1, 0}, {0, -1} };

int n, k;
int a[MAX_SIZE][MAX_SIZE];
int board[MAX_SIZE][MAX_SIZE];
int vis[MAX_SIZE][MAX_SIZE], used[MAX];
vector < Cell > cells[MAX_COLORS];

void getCells(int color)
{
	Cell cur, nxt;
	queue <Cell> q;
	for (int i = 0; i < (int)cells[color].size(); i++)
	{
		q.push(cells[color][i]);
		a[cells[color][i].row][cells[color][i].col] = -1;
	}
	cells[color].clear();
	
	while (!q.empty())
	{
		cur = q.front(); q.pop();
		for (int i = 0; i < 4; i++)
		{
			nxt.row = cur.row + dir[i][0]; if (nxt.row < 0 || nxt.row >= n) continue;
			nxt.col = cur.col + dir[i][1]; if (nxt.col < 0 || nxt.col >= n) continue;
			if (a[nxt.row][nxt.col] == color)
			{
				a[nxt.row][nxt.col] = -1;
				q.push(nxt);
			}
			else if (a[nxt.row][nxt.col] != -1)
				cells[a[nxt.row][nxt.col]].push_back(nxt);
		}
	}
}

void checkSolution()
{
	cells[a[ansRow][ansCol]].push_back(Cell(ansRow, ansCol));
	getCells(a[ansRow][ansCol]);
	for (int i = 0; i < ansMoves; i++)
		getCells(moves[i]);

	int good = 1;
	for (int i = 0; i < n; i++)
		for (int c = 0; c < n; c++)
			if (a[i][c] != -1) good = 0;
	if (good)
		fprintf(stdout, "Solution is correct!\n");
	else
		fprintf(stdout, "Solution failed!\n");
	system("pause");
}

void readInput()
{
	FILE* in = fopen("flood-it.in", "rt");
	fscanf(in, "%d %d", &n, &k);
	for (int i = 0; i < n; i++)
		for (int c = 0; c < n; c++)
			fscanf(in, "%d", &a[i][c]);
	fclose(in);
}

void readOutput()
{
	FILE* in = fopen("flood-it.out", "rt");
	fscanf(in, "%d", &ansMoves);
	fscanf(in, "%d %d", &ansRow, &ansCol);
	for (int i = 0; i < ansMoves; i++)
		fscanf(in, "%d", &moves[i]);
	fclose(in);
}

int main(void)
{
	readInput();
	readOutput();
	checkSolution();
	return 0;
}
